diff --git a/drivers/gpu/drm/drm_edid.c b/drivers/gpu/drm/drm_edid.c
index 990b190..7062e37 100644
--- a/drivers/gpu/drm/drm_edid.c
+++ b/drivers/gpu/drm/drm_edid.c
@@ -4925,6 +4925,63 @@ static bool is_hdmi2_sink(struct drm_connector *connector)
 EXPORT_SYMBOL(drm_hdmi_avi_infoframe_from_display_mode);
 
 /**
+ * drm_hdmi_avi_infoframe_colorspace() - fill the HDMI AVI infoframe
+ *                                       colorspace information
+ * @frame: HDMI AVI infoframe
+ * @conn_state: connector state
+ */
+void
+drm_hdmi_avi_infoframe_colorspace(struct hdmi_avi_infoframe *frame,
+				  const struct drm_connector_state *conn_state)
+{
+	u32 colorimetry_val = conn_state->colorspace &
+				FULL_COLORIMETRY_MASK;
+
+	switch (colorimetry_val) {
+	case DRM_MODE_COLORIMETRY_NO_DATA:
+		colorimetry_val = HDMI_COLORIMETRY_NO_DATA;
+		break;
+	case HDMI_COLORIMETRY_SMPTE_170M:
+		colorimetry_val = HDMI_COLORIMETRY_SMPTE_170M;
+		break;
+	case DRM_MODE_COLORIMETRY_BT709:
+		colorimetry_val = HDMI_COLORIMETRY_BT709;
+		break;
+	case DRM_MODE_COLORIMETRY_XVYCC_601:
+		colorimetry_val = HDMI_COLORIMETRY_XVYCC_601;
+		break;
+	case DRM_MODE_COLORIMETRY_XVYCC_709:
+		colorimetry_val = HDMI_COLORIMETRY_XVYCC_709;
+		break;
+	case DRM_MODE_COLORIMETRY_SYCC_601:
+		colorimetry_val = HDMI_COLORIMETRY_SYCC_601;
+		break;
+	case DRM_MODE_COLORIMETRY_OPYCC_601:
+		colorimetry_val = HDMI_COLORIMETRY_OPYCC_601;
+		break;
+	case DRM_MODE_COLORIMETRY_OPRGB:
+		colorimetry_val = HDMI_COLORIMETRY_OPRGB;
+		break;
+	case DRM_MODE_COLORIMETRY_BT2020_RGB:
+	case DRM_MODE_COLORIMETRY_BT2020_YCC:
+		colorimetry_val = HDMI_COLORIMETRY_BT2020_RGB;
+		break;
+	case DRM_MODE_COLORIMETRY_BT2020_CYCC:
+		colorimetry_val = HDMI_COLORIMETRY_BT2020_CYCC;
+		break;
+	default:
+		/* ToDo: DCI-P3 will be handled as part of ACE enabling */
+		colorimetry_val = HDMI_COLORIMETRY_NO_DATA;
+		break;
+	}
+
+	frame->colorimetry = colorimetry_val & NORMAL_COLORIMETRY_MASK;
+	frame->extended_colorimetry = (colorimetry_val >> 2) &
+					EXTENDED_COLORIMETRY_MASK;
+}
+EXPORT_SYMBOL(drm_hdmi_avi_infoframe_colorspace);
+
+/**
  * drm_hdmi_avi_infoframe_quant_range() - fill the HDMI AVI infoframe
  *                                        quantization range information
  * @frame: HDMI AVI infoframe
diff --git a/include/drm/drm_connector.h b/include/drm/drm_connector.h
index 37d4dda..7b8062c 100644
--- a/include/drm/drm_connector.h
+++ b/include/drm/drm_connector.h
@@ -288,6 +288,26 @@ enum drm_panel_orientation {
 #define DRM_MODE_DP_COLORIMETRY_RGB_WIDE_GAMUT		16
 #define DRM_MODE_DP_COLORIMETRY_SCRGB			17
 
+/* HDMI Colorspace Spec Definitions */
+#define FULL_COLORIMETRY_MASK				0x1FF
+#define NORMAL_COLORIMETRY_MASK				0x3
+#define EXTENDED_COLORIMETRY_MASK			0x7
+#define EXTENDED_ACE_COLORIMETRY_MASK			0xF
+
+#define HDMI_COLORIMETRY_NO_DATA			0x0
+#define HDMI_COLORIMETRY_SMPTE_170M			0x1
+#define HDMI_COLORIMETRY_BT709				0x2
+#define HDMI_COLORIMETRY_XVYCC_601			0x3
+#define HDMI_COLORIMETRY_XVYCC_709			0x7
+#define HDMI_COLORIMETRY_SYCC_601			0xB
+#define HDMI_COLORIMETRY_OPYCC_601			0xF
+#define HDMI_COLORIMETRY_OPRGB				0x13
+#define HDMI_COLORIMETRY_BT2020_CYCC			0x17
+#define HDMI_COLORIMETRY_BT2020_RGB			0x1C
+#define HDMI_COLORIMETRY_BT2020_YCC			0x1C
+#define HDMI_COLORIMETRY_DCI_P3_RGB_D65			0x1F
+#define HDMI_COLORIMETRY_DCI_P3_RGB_THEATER		0x3F
+
 /**
  * struct drm_display_info - runtime data about the connected sink
  *
diff --git a/include/drm/drm_edid.h b/include/drm/drm_edid.h
index 8dc1a08..9d3b5b9 100644
--- a/include/drm/drm_edid.h
+++ b/include/drm/drm_edid.h
@@ -331,6 +331,7 @@ struct cea_sad {
 
 struct drm_encoder;
 struct drm_connector;
+struct drm_connector_state;
 struct drm_display_mode;
 
 int drm_edid_to_sad(struct edid *edid, struct cea_sad **sads);
@@ -358,6 +359,11 @@ int drm_av_sync_delay(struct drm_connector *connector,
 drm_hdmi_vendor_infoframe_from_display_mode(struct hdmi_vendor_infoframe *frame,
 					    struct drm_connector *connector,
 					    const struct drm_display_mode *mode);
+
+void
+drm_hdmi_avi_infoframe_colorspace(struct hdmi_avi_infoframe *frame,
+				  const struct drm_connector_state *conn_state);
+
 void
 drm_hdmi_avi_infoframe_quant_range(struct hdmi_avi_infoframe *frame,
 				   struct drm_connector *connector,